<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<meta charset="<?php bloginfo('charset'); ?>" />
<meta http-equiv="X-UA-Compatible" content="IE=9" />
<title><?php
	global $page,$paged;
	wp_title('|',true,'right');
	bloginfo('name');
	$site_description = get_bloginfo('description','display');
	if ($site_description && (is_home() || is_front_page()))	echo " | $site_description";
	if ($paged >= 2 || $page >= 2) echo ' | ' . sprintf(__('Page %s','kippis'),max($paged,$page));
?></title>
<link rel="profile" href="http://gmpg.org/xfn/11" />
<link rel="stylesheet" href="<?php bloginfo('stylesheet_url'); ?>" type="text/css" media="screen" />
<link rel="pingback" href="<?php bloginfo('pingback_url'); ?>" />
<?php
if (is_singular() && get_option('thread_comments')) wp_enqueue_script('comment-reply');
wp_enqueue_script('jquery');
wp_enqueue_script('kippis_script_js',get_template_directory_uri() . '/inc/script.js');
global $kippis_is_smartphone;
global $kippis_options;
wp_head();
kippis_enable_sidebars();
kippis_get_css();
if ($kippis_is_smartphone) {
  ?>
  <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
  <?php
}
?>
</head>
<body <?php body_class(); ?>>
<div id="all">
  <div id="page">
      <header id="pagehead">
<!-- Searchform Begin -->
        <?php
        if ('blank' == get_header_textcolor()) {
          echo '<div class="only-search' . (!empty($header_image) ? ' with-image' : '') . '">';
          get_search_form();
          echo '</div>';
        }
        else get_search_form();
        ?>
<!-- Searchform End -->
       <hgroup>
         <h1 id="site-title">
           <?php echo '<a href="' . esc_url(home_url('/')) . '" title="' . esc_attr(get_bloginfo('name','display')) . '" rel="home">' . get_bloginfo('name') . '</a>'; ?>
         </h1>
         <?php if (!$kippis_is_smartphone) { ?>
           <h2 id="site-description"><?php bloginfo('description'); ?></h2>
         <?php } ?>
       </hgroup>
     </header>
<!-- Menu Begin -->
    <?php
      if (!$kippis_is_smartphone) {
        echo '<nav id="main_menu" role="navigation">';
        wp_nav_menu(array('theme_location' => 'primary'));
        echo '</nav>';
      }
      else {
        echo '<div id="main_menu_mobile_toggle" onclick="main_menu_mobile_toggle(' . "'#main_menu_mobile'" . ');">'
           . __('Menu','kippis')
           . '</div>'
           . '<nav id="main_menu_mobile" role="navigation">';
        wp_nav_menu(array('theme_location' => 'primary','container_class' => 'menu_mobile'));
        echo '</nav>';
      }
    ?>
<!-- Menu End -->
    <section id="pagebody">

