<?php
add_action('admin_print_scripts','kippis_options_js'  );
add_action('admin_print_styles' ,'kippis_options_css' );
add_action('admin_menu'         ,'kippis_options_menu');

function kippis_options_js()
{
  wp_enqueue_script('farbtastic');
  wp_register_script('kippis_options_js',get_template_directory_uri() . '/options/script.js',false);
  wp_enqueue_script('kippis_options_js');
}

function kippis_options_css()
{
  wp_enqueue_style('farbtastic');
  wp_register_style('kippis_options_css',get_template_directory_uri() . '/options/style.css',false);
  wp_enqueue_style('kippis_options_css');
}

function kippis_options_menu()
{
  include get_template_directory() . '/options/init_fields.php';
  if (isset($_GET['page']) && $_GET['page'] == basename(__FILE__)) {
    //
    //  action: save
    //
    if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'save')) {
      foreach ($options as $option) {
        if (($option['type'] == 'open') || ($option['type'] == 'close') || ($option['type'] == 'displayonly')) continue;
        if ($option['type'] == 'image') {
          if ((!empty($_FILES)) && (!empty($_FILES[$option['id']])) && (!empty($_FILES[$option['id']]['name']))) {
            $the_value = array();
            if (preg_match('/(jpg|jpeg|png|gif)$/',$_FILES[$option['id']]['type'])) {
              $files_one = $_FILES[$option['id']];
              $overrides = array('test_form' => false);
              $uploaded = wp_handle_upload($files_one,$overrides);
              if (isset($uploaded['url'])) {
                $image_info = getimagesize($uploaded['file']);
                $the_value['file'  ] = $uploaded['file'];
                $the_value['url'   ] = $uploaded['url' ];
                $the_value['width' ] = $image_info[0];
                $the_value['height'] = $image_info[1];
                $_REQUEST[$option['id']] = true;
              }
            }
          }  // upload
        }  // type == image
        else {
          if (!isset($_REQUEST[$option['id']])) {
            if ($option['type'] == 'checkbox') $_REQUEST[$option['id']] = '';
          }
          if (!is_array($_REQUEST[$option['id']])) $the_value = stripslashes($_REQUEST[$option['id']]);
          else                                     $the_value =    serialize($_REQUEST[$option['id']]);
        }
        if (isset($_REQUEST[$option['id']])) {
          if (isset($the_value)) {
            if ($option['type'] == 'color') {
              $len = strlen($the_value);
              if ((($len != 4) && ($len != 7)) || ($the_value{0} != '#')) $the_value = '';
            }
            update_option($option['id'],$the_value);
          }
        }
      }
      header('Location: admin.php?page=kippis_admin.php&saved=true');
      die;
    }
    //
    //  action: reset
    //
    else if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'reset')) {
      //  Loop the options and delete them (setting the default values will happen on next page load).
      foreach ($options as $option) {
        if (isset($option['id'])) delete_option($option['id']);
      }
      //  Insert into the wp_options table.
      foreach ($options as $option) {
        if (($option['type'] == 'open') || ($option['type'] == 'close') || ($option['type'] == 'displayonly')) continue;
        update_option($option['id'],$option['std']);
      }
      header("Location: admin.php?page=kippis_admin.php&reset=true");
      die;
    }
    //
    //  action: delete (all oprtions table data)
    //
    else if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'delete')) {
      foreach ($options as $option) {
        if (isset($option['id'])) delete_option($option['id']);
      }
      header("Location: themes.php");
      die;
    }
    //
    //  action: the end
    //
  }
  //  Required, for some reason.
  add_theme_page(__('Kippis - Options','kippis')
                ,__('Theme Options','kippis')
                ,'edit_themes'
                ,basename(__FILE__)
                ,'kippis_options_menu_form'
                );
  //add_menu_page(__('Kippis - Options','kippis')
  //             ,__('Theme Options','kippis')
  //             ,'edit_themes'
  //             ,basename(__FILE__)
  //             ,'kippis_options_menu_form'
  //             ,get_template_directory_uri() . '/pix/icon_menu_admin.png'
  //             ,61
  //             );
}

function kippis_options_menu_form()
{
  $menubar_html = '';
  $fields_html  = '';
  include get_template_directory() . '/options/init_fields.php';
  include get_template_directory() . '/options/get_fields.php';
  $save_button = '<div class="kippis_options-actions" style="clear:both;">'
               . '  <input type="hidden" name="action" value="save" />'
               . '  <input type="submit" class="button-primary" value="Save options" />'
               . '</div>'
               ;
               ?>
  <a href="http://birchware.se/wordpress/kippis" target="_blank" title="<?php _e('Kippis home','kippis'); ?>">
  <?php echo '<img src="' . get_template_directory_uri() . '/pix/icon_menu_admin.png' . '" class="icon32" />' ?>
  </a>
  <form method="post" enctype="multipart/form-data">
  <span style="float:right;margin-right:2em;">
      <div class="kippis_options-actions">
        <input type="hidden" name="action" value="reset" />
        <input type="submit" class="button-secondary" value="Reset" onclick="return confirm('<?php _e('Really reset all options to their default values?','kippis'); ?>');" />
      </div>
    </span>
  </form>
  <div style="clear:both;margin-bottom:1em;"></div>
  <div style="clear:both;"></div>
  <form method="post" enctype="multipart/form-data">
    <div id="kippis_options">
      <?php echo $save_button; ?>
      <div id="kippis_options-menubar">
        <ul>
          <?php echo $menubar_html; ?>
        </ul>
      </div>
      <div id="kippis_options-content">
        <?php echo $fields_html; ?>
      </div>
      <?php echo $save_button; ?>
    </div>
  </form>
<?php
  $onclick = "jQuery('#kippis_options-delete').show();jQuery(this).hide();";
  echo '<span style="float:right;margin-right:2em;"><button onclick="' . $onclick . '" class="button-secondary">' . __('Uninstall instructions','kippis') . '</button></span>'
     . '<div id="kippis_options-delete">'
     .   '<h2>' . __('This is for when you want to uninstall the theme, and remove any trace of it from the database.'                                     ,'kippis') . '</h2>'
     .   '<h3>' . __('After you have confirmed the deletion, you will be taken to the Appearance/Themes page, where you can replace and delete the theme.' ,'kippis') . '</h3>'
     .   '<h3>' . __('You must do this before you activate another theme, since upon inactivation, this menu option will disappear.'                       ,'kippis') . '</h3>'
     .   '<form method="post" enctype="multipart/form-data">'
     .     '<input type="hidden" name="action" value="delete" />'
     .     '<span style="float:right;"><input type="submit" class="button-primary" value="' . __('Delete','kippis') . '" onclick="return confirm(' . "'" . __('Really delete all options?','kippis') . "'" . ');" /></span>'
     .   '</form>'
     . '</div>'
     ;
  echo '<div style="clear:both;"></div>';
}

